<?php

namespace App\Helpers;

use Illuminate\Support\Arr;
use Illuminate\Support\Facades\DB;

class Helpers
{
    public static function successResponse($data)
    {
        return response()->json([
            'statusCode' => 200,
            'body' => $data,
            'error' => null,
        ]);
    }

    public static function errorResponse($message, $statusCode = 500)
    {
        return response()->json([
            'statusCode' => $statusCode,
            'body' => null,
            'error' => $message,
        ], $statusCode);
    }

    public static function convertTypes($result, $mapping)
    {
        $convertedResults = [];

        foreach ($result as $row) {
            $convertedRow = [];

            foreach ($row as $fieldName => $fieldValue) {
                
                if (isset($mapping[$fieldName])) {
                    if($mapping[$fieldName] == 'boolVal' && $fieldValue == 0){
                        $convertedRow[$fieldName] = false;
                    } else {
                        $convertedRow[$fieldName] = ($fieldValue != null) ? call_user_func($mapping[$fieldName], $fieldValue) : null;
                    }
                } else {
                    $convertedRow[$fieldName] = $fieldValue;
                }
            }

            $convertedResults[] = $convertedRow;
        }

        return $convertedResults;
    }

    public static function pegaIdUsuario($request){

        $accountId = $request->get('accountId');

        $usuarios = DB::select('select id from usuarios where erpusb_usuario_id = ?', [$accountId]);

        $usuario = Arr::first($usuarios);

        return $usuario->id;
        
    }

    public static function pegaIdPessoa($request){

        $accountId = $request->get('accountId');

        $usuarios = DB::select('select id from pessoas where usuario_id = ?', [$accountId]);

        $usuario = Arr::first($usuarios);

        return $usuario->id;
        
    }
}